Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling03.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling03.vcproj	(revision 2800)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling03.vcproj	(revision 2800)
@@ -0,0 +1,357 @@
+<?xml version="1.0" encoding="Windows-1252"?>
+<VisualStudioProject
+	ProjectType="Visual C++"
+	Version="7.10"
+	Name="FriendlyCulling"
+	ProjectGUID="{D1E30B8F-194B-4487-8303-D2CF90ED0048}"
+	Keyword="Win32Proj">
+	<Platforms>
+		<Platform
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration
+			Name="Debug|Win32"
+			OutputDirectory="bin/Debug"
+			IntermediateDirectory="bin/Debug"
+			ConfigurationType="1"
+			CharacterSet="2">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="0"
+				AdditionalIncludeDirectories="libs;libs/GL;libs/Devil/include;src;libs/Zlib/include"
+				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE"
+				MinimalRebuild="TRUE"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="5"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="4"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="glut32.lib glew32s.lib glew32.lib DevIL.lib ILUT.lib zlib.lib"
+				OutputFile="$(OutDir)/FriendlyCulling.exe"
+				LinkIncremental="2"
+				AdditionalLibraryDirectories="libs/GL;libs/Devil/lib;libs/Zlib/lib"
+				GenerateDebugInformation="TRUE"
+				ProgramDatabaseFile="$(OutDir)/FriendlyCulling.pdb"
+				SubSystem="1"
+				TargetMachine="1"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration
+			Name="Release|Win32"
+			OutputDirectory="bin/Release"
+			IntermediateDirectory="obj/Release"
+			ConfigurationType="1"
+			CharacterSet="2"
+			WholeProgramOptimization="TRUE">
+			<Tool
+				Name="VCCLCompilerTool"
+				Optimization="3"
+				GlobalOptimizations="TRUE"
+				InlineFunctionExpansion="2"
+				EnableIntrinsicFunctions="TRUE"
+				FavorSizeOrSpeed="1"
+				OmitFramePointers="TRUE"
+				EnableFiberSafeOptimizations="TRUE"
+				OptimizeForWindowsApplication="TRUE"
+				AdditionalIncludeDirectories="libs;libs/GL;libs/Devil/include;src;libs/Zlib/include"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE"
+				StringPooling="TRUE"
+				RuntimeLibrary="4"
+				EnableEnhancedInstructionSet="2"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool
+				Name="VCCustomBuildTool"/>
+			<Tool
+				Name="VCLinkerTool"
+				AdditionalDependencies="glut32.lib glew32s.lib glew32.lib DevIL.lib ILUT.lib zlib.lib"
+				OutputFile="$(OutDir)/FriendlyCulling.exe"
+				LinkIncremental="1"
+				AdditionalLibraryDirectories="libs/GL;libs/Devil/lib;libs/Zlib/lib"
+				GenerateDebugInformation="TRUE"
+				SubSystem="1"
+				OptimizeReferences="2"
+				EnableCOMDATFolding="2"
+				OptimizeForWindows98="1"
+				TargetMachine="1"/>
+			<Tool
+				Name="VCMIDLTool"/>
+			<Tool
+				Name="VCPostBuildEventTool"/>
+			<Tool
+				Name="VCPreBuildEventTool"/>
+			<Tool
+				Name="VCPreLinkEventTool"/>
+			<Tool
+				Name="VCResourceCompilerTool"/>
+			<Tool
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool
+				Name="VCWebDeploymentTool"/>
+			<Tool
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter
+			Name="utils"
+			Filter="">
+			<Filter
+				Name="Source Files"
+				Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
+				UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
+				<File
+					RelativePath=".\src\AxisAlignedBox3.cpp">
+				</File>
+				<File
+					RelativePath=".\src\BvhLoader.cpp">
+				</File>
+				<File
+					RelativePath=".\src\common.cpp">
+				</File>
+				<File
+					RelativePath=".\src\gzstream.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Material.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Matrix4x4.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Plane3.cpp">
+				</File>
+				<File
+					RelativePath=".\src\SceneQuery.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Texture.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Triangle3.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Vector3.cpp">
+				</File>
+			</Filter>
+			<Filter
+				Name="Timers"
+				Filter="">
+				<File
+					RelativePath=".\src\Timer\BenchTimer.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Timer\BenchTimer.h">
+				</File>
+				<File
+					RelativePath=".\src\Timer\merror.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Timer\merror.h">
+				</File>
+				<File
+					RelativePath=".\src\Timer\mstring.h">
+				</File>
+				<File
+					RelativePath=".\src\Timer\PerfTimer.h">
+				</File>
+				<File
+					RelativePath=".\src\Timer\PerfTimerSkeleton.h">
+				</File>
+				<File
+					RelativePath=".\src\Timer\RDTSCTimer.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Timer\RDTSCTimer.h">
+				</File>
+			</Filter>
+			<Filter
+				Name="Header Files"
+				Filter="h;hpp;hxx;hm;inl;inc;xsd"
+				UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
+				<File
+					RelativePath=".\src\AxisAlignedBox3.h">
+				</File>
+				<File
+					RelativePath=".\src\BvhLoader.h">
+				</File>
+				<File
+					RelativePath=".\src\common.h">
+				</File>
+				<File
+					RelativePath=".\src\glInterface.h">
+				</File>
+				<File
+					RelativePath=".\src\gzstream.h">
+				</File>
+				<File
+					RelativePath=".\src\Matrix4x4.h">
+				</File>
+				<File
+					RelativePath=".\src\Plane3.h">
+				</File>
+				<File
+					RelativePath=".\src\SceneQuery.h">
+				</File>
+				<File
+					RelativePath=".\src\Texture.h">
+				</File>
+				<File
+					RelativePath=".\src\Triangle3.h">
+				</File>
+				<File
+					RelativePath=".\src\Vector3.h">
+				</File>
+			</Filter>
+		</Filter>
+		<Filter
+			Name="scene"
+			Filter="">
+			<Filter
+				Name="Header Files"
+				Filter="">
+				<File
+					RelativePath=".\src\Bvh.h">
+				</File>
+				<File
+					RelativePath=".\src\Camera.h">
+				</File>
+				<File
+					RelativePath=".\src\Geometry.h">
+				</File>
+				<File
+					RelativePath=".\src\Material.h">
+				</File>
+				<File
+					RelativePath=".\src\OcclusionQuery.h">
+				</File>
+				<File
+					RelativePath=".\src\RenderQueue.h">
+				</File>
+				<File
+					RelativePath=".\src\RenderState.h">
+				</File>
+				<File
+					RelativePath=".\src\ResourceManager.h">
+				</File>
+				<File
+					RelativePath=".\src\SceneEntity.h">
+				</File>
+				<File
+					RelativePath=".\src\Visualization.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Visualization.h">
+				</File>
+			</Filter>
+			<Filter
+				Name="Source Files"
+				Filter="">
+				<File
+					RelativePath=".\src\Bvh.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Camera.cpp">
+				</File>
+				<File
+					RelativePath=".\src\chcdemo.cpp">
+				</File>
+				<File
+					RelativePath=".\src\Geometry.cpp">
+				</File>
+				<File
+					RelativePath=".\src\OcclusionQuery.cpp">
+				</File>
+				<File
+					RelativePath=".\src\RenderQueue.cpp">
+				</File>
+				<File
+					RelativePath=".\src\RenderState.cpp">
+				</File>
+				<File
+					RelativePath=".\src\ResourceManager.cpp">
+				</File>
+				<File
+					RelativePath=".\src\SceneEntity.cpp">
+				</File>
+			</Filter>
+		</Filter>
+		<Filter
+			Name="traversal"
+			Filter="">
+			<Filter
+				Name="Header Files"
+				Filter="">
+				<File
+					RelativePath=".\src\CHCPlusPlusTraverser.h">
+				</File>
+				<File
+					RelativePath=".\src\CHCTraverser.h">
+				</File>
+				<File
+					RelativePath=".\src\FrustumCullingTraverser.h">
+				</File>
+				<File
+					RelativePath=".\src\RenderTraverser.h">
+				</File>
+				<File
+					RelativePath=".\src\StopAndWaitTraverser.h">
+				</File>
+			</Filter>
+			<Filter
+				Name="Source Files"
+				Filter="">
+				<File
+					RelativePath=".\src\CHCPlusPlusTraverser.cpp">
+				</File>
+				<File
+					RelativePath=".\src\CHCTraverser.cpp">
+				</File>
+				<File
+					RelativePath=".\src\FrustumCullingTraverser.cpp">
+				</File>
+				<File
+					RelativePath=".\src\RenderTraverser.cpp">
+				</File>
+				<File
+					RelativePath=".\src\StopAndWaitTraverser.cpp">
+				</File>
+			</Filter>
+		</Filter>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.sln
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.sln	(revision 2800)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/FriendlyCulling.sln	(revision 2800)
@@ -0,0 +1,20 @@
+﻿
+Microsoft Visual Studio Solution File, Format Version 9.00
+# Visual Studio 2005
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "chc_revisited", "FriendlyCulling.vcproj", "{03661866-4093-4B02-B26A-028EA91AF023}"
+EndProject
+Global
+	GlobalSection(SolutionConfigurationPlatforms) = preSolution
+		Debug|Win32 = Debug|Win32
+		Release|Win32 = Release|Win32
+	EndGlobalSection
+	GlobalSection(ProjectConfigurationPlatforms) = postSolution
+		{03661866-4093-4B02-B26A-028EA91AF023}.Debug|Win32.ActiveCfg = Debug|Win32
+		{03661866-4093-4B02-B26A-028EA91AF023}.Debug|Win32.Build.0 = Debug|Win32
+		{03661866-4093-4B02-B26A-028EA91AF023}.Release|Win32.ActiveCfg = Release|Win32
+		{03661866-4093-4B02-B26A-028EA91AF023}.Release|Win32.Build.0 = Release|Win32
+	EndGlobalSection
+	GlobalSection(SolutionProperties) = preSolution
+		HideSolutionNode = FALSE
+	EndGlobalSection
+EndGlobal
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/CHCTraverser.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/CHCTraverser.h	(revision 2792)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/CHCTraverser.h	(revision 2800)
@@ -14,8 +14,10 @@
 public:
 	CHCTraverser();
-	//~CHCTraverser();
+
+	virtual int GetType() const { return CHC; }
 
 	
 protected:
+
 	/** Optimized query querying the node geometry instead
 		of the bounding box
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/StopAndWaitTraverser.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/StopAndWaitTraverser.h	(revision 2782)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/StopAndWaitTraverser.h	(revision 2800)
@@ -16,5 +16,6 @@
 	StopAndWaitTraverser();
 
-	//~StopAndWaitTraverser();
+	int GetType() const { return STOP_AND_WAIT; }
+
 
 protected:
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/CHCPlusPlusTraverser.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/CHCPlusPlusTraverser.h	(revision 2782)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/CHCPlusPlusTraverser.h	(revision 2800)
@@ -33,5 +33,6 @@
 	
 	CHCPlusPlusTraverser();
-	//~CHCPlusPlusTraverser();
+
+	virtual int GetType() const { return CHCPLUSPLUS;}
 
 
@@ -45,5 +46,5 @@
 	/** Computes the next multiquery.
 	*/
-	OcclusionQuery *GetNextMultiQuery(BvhNodeQueue &iqueue);
+	OcclusionQuery *GetNextMultiQuery(BvhNodeContainer &iqueue);
 	/** Issues batched multiqueries.
 	*/
@@ -59,6 +60,6 @@
 	QueryQueue mQueryQueue;
 
-	BvhNodeQueue mIQueue;
 	BvhNodeQueue mVQueue;
+	BvhNodeContainer mIQueue;
 
 	VisibilityPredictor mVisibilityPredictor;
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderTraverser.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderTraverser.cpp	(revision 2798)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderTraverser.cpp	(revision 2800)
@@ -27,6 +27,10 @@
 	mNumIssuedQueries = 0;
 	mNumStateChanges = 0;
+	mNumBatches = 0;
 
 	mRenderTime = 0;
+	mWaitTime = 0;
+	mQueryTime = 0;
+	mRestTime = 0;
 }
 
@@ -132,4 +136,6 @@
 	PerfTimer timer;
 	
+	glFinish();
+
 	timer.Start();
 
@@ -154,4 +160,6 @@
 	// render the contents of the render queue
 	if (mUseRenderQueue) ApplyRenderQueue();
+	
+	// reset the render state
 	mRenderState->Reset();
 
@@ -159,7 +167,16 @@
 	glDisableClientState(GL_NORMAL_ARRAY);
 
+	glFinish();
+
+
 	mStats.mRenderTime = timer.Elapsedms();
 	
+	//Debug << "type: " << GetType() << endl;
 	//if (mUseRenderQueue) Debug << "rq sort: " << 1e3f * mRenderQueue.sortTimer.TotalTime() << " ms" << endl;
+	/*
+	Debug << "wait time: " << 1e3f * waitTimer.TotalTime() << " ms" << endl;
+	Debug << "query time: " << 1e3f * queryTimer.TotalTime() << " ms" << endl;
+	Debug << "rest time: " << 1e3f * restTimer.TotalTime() << " ms" << endl;
+	*/
 }
 
@@ -219,8 +236,12 @@
 OcclusionQuery *RenderTraverser::IssueOcclusionQuery(BvhNode *node)
 {
+	queryTimer.Entry();
+
 	OcclusionQuery *query = mQueryHandler.RequestQuery();
 	query->AddNode(node);
 
 	IssueOcclusionQuery(*query);
+
+	queryTimer.Exit();
 
 	return query;
@@ -254,4 +275,7 @@
 		++ mStats.mNumStateChanges;
 		 
+	if (mRenderQueue.GetSize() > 0)
+		++ mStats.mNumBatches;
+
 	mRenderQueue.Apply();
 }
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Bvh.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Bvh.cpp	(revision 2796)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Bvh.cpp	(revision 2800)
@@ -109,4 +109,5 @@
 	mIsFrustumCulled = false;
 	mIsNew = true;
+	mLastQueriedFrame = -1;
 }
 
@@ -609,5 +610,5 @@
 					GL_STATIC_DRAW_ARB);
 
-	//glBindBufferARB(GL_ARRAY_BUFFER_ARB, 0);
+	glBindBufferARB(GL_ARRAY_BUFFER_ARB, 0);
 
 	// data handled by graphics driver from now on
@@ -904,4 +905,6 @@
 		}
 	}
+
+	ResetNodeClassifications();
 }
 
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/OcclusionQuery.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/OcclusionQuery.cpp	(revision 2786)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/OcclusionQuery.cpp	(revision 2800)
@@ -65,5 +65,5 @@
 QueryHandler::QueryHandler(): mCurrentQueryIdx(0) 
 {
-	Allocate(1000);
+	Allocate(500);
 }
 
@@ -99,4 +99,5 @@
 {
 	CLEAR_CONTAINER(mOcclusionQueries);
+	
 	mCurrentQueryIdx = 0;
 	mOcclusionQueries.clear();
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/FrustumCullingTraverser.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/FrustumCullingTraverser.h	(revision 2782)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/FrustumCullingTraverser.h	(revision 2800)
@@ -16,4 +16,6 @@
 	FrustumCullingTraverser();
 
+	virtual int GetType() const { return CULL_FRUSTUM; }
+
 protected:
 	/** Traverses and renders the scene with the specified method
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneQuery.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneQuery.h	(revision 2796)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneQuery.h	(revision 2800)
@@ -4,4 +4,5 @@
 #include "common.h"
 #include "AxisAlignedBox3.h"
+
 
 namespace CHCDemoEngine
@@ -22,5 +23,4 @@
 	bool CalcIntersection(Vector3 &pt);
 
-
 protected:
 
@@ -32,5 +32,5 @@
 	AxisAlignedBox3 mSceneBox;
 
-	float *mDepth;
+	unsigned char *mDepth;
 };
 
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/StopAndWaitTraverser.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/StopAndWaitTraverser.cpp	(revision 2795)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/StopAndWaitTraverser.cpp	(revision 2800)
@@ -33,5 +33,7 @@
 				OcclusionQuery *query = IssueOcclusionQuery(node);
 
+				waitTimer.Entry();
 				bool visible = query->GetQueryResult() > mVisibilityThreshold;
+				waitTimer.Exit();
 
 				if (visible)
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/gzstream.h
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/gzstream.h	(revision 2800)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/gzstream.h	(revision 2800)
@@ -0,0 +1,146 @@
+// ============================================================================
+// gzstream, C++ iostream classes wrapping the zlib compression library.
+// Copyright (C) 2001  Deepak Bandyopadhyay, Lutz Kettner
+//
+// This library is free software; you can redistribute it and/or
+// modify it under the terms of the GNU Lesser General Public
+// License as published by the Free Software Foundation; either
+// version 2.1 of the License, or (at your option) any later version.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+// Lesser General Public License for more details.
+//
+// You should have received a copy of the GNU Lesser General Public
+// License along with this library; if not, write to the Free Software
+// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+// ============================================================================
+//
+// File          : gzstream.h
+// Revision      : $Revision: 1.1 $
+// Revision_date : $Date: 2004/02/16 14:46:00 $
+// Author(s)     : Deepak Bandyopadhyay, Lutz Kettner
+// 
+// Standard streambuf implementation following Nicolai Josuttis, "The 
+// Standard C++ Library".
+// ============================================================================
+
+#ifndef GZSTREAM_H
+#define GZSTREAM_H 1
+
+#include <zlib.h>
+
+// standard C++ with new header file names and std:: namespace
+#include <iostream>
+#include <fstream>
+
+#ifdef GZSTREAM_NAMESPACE
+namespace GZSTREAM_NAMESPACE {
+#endif
+
+// ----------------------------------------------------------------------------
+// Internal classes to implement gzstream. See below for user classes.
+// ----------------------------------------------------------------------------
+
+   // size of data buff
+#define gzbufferSize  303   
+
+
+
+#define STREAMBUF std::streambuf 
+#define ISTREAM std::istream
+#define OSTREAM std::ostream
+
+//#define STREAMBUF streambuf 
+//#define ISTREAM istream
+//#define OSTREAM ostream
+
+class gzstreambuf : public STREAMBUF {
+
+private:
+    // totals 512 bytes under g++ for igzstream at the end.
+
+    gzFile           file;               // file handle for compressed file
+    char             buffer[gzbufferSize]; // data buffer
+    char             opened;             // open/close state of stream
+    int              mode;               // I/O mode
+
+    int flush_buffer();
+public:
+    gzstreambuf() : opened(0) {
+        setp( buffer, buffer + (gzbufferSize-1));
+        setg( buffer + 4,     // beginning of putback area
+              buffer + 4,     // read position
+              buffer + 4);    // end position      
+        // ASSERT: both input & output capabilities will not be used together
+    }
+    int is_open() const { return opened; }
+    gzstreambuf* open( const char* name, int open_mode);
+    gzstreambuf* close();
+    ~gzstreambuf() { close(); }
+  
+    virtual int     overflow( int c = EOF);
+    virtual int     underflow();
+    virtual int     sync();
+
+};
+
+class gzstreambase : virtual public std::ios {
+
+protected:
+    gzstreambuf buf;
+public:
+  gzstreambase() { init(&buf); }
+  gzstreambase( const char* name, int open_mode);
+  ~gzstreambase();
+  void open( const char* name, int open_mode);
+  void close();
+  gzstreambuf* rdbuf() { return &buf; }
+  int is_open() const { return buf.is_open(); }
+};
+
+// ----------------------------------------------------------------------------
+// User classes. Use igzstream and ogzstream analogously to ifstream and
+// ofstream respectively. They read and write files based on the gz* 
+// function interface of the zlib. Files are compatible with gzip compression.
+// ----------------------------------------------------------------------------
+
+  
+
+  class igzstream : public gzstreambase, public ISTREAM {
+  
+  public:
+    igzstream() : gzstreambase(), ISTREAM( &buf )  {} 
+    
+    igzstream( const char* name, int open_mode = std::ios::in)
+      : gzstreambase( name, open_mode), ISTREAM( &buf) {}
+    
+    gzstreambuf* rdbuf() { return gzstreambase::rdbuf(); }
+    
+    void open( const char* name, int open_mode = std::ios::in) {
+      gzstreambase::open( name, open_mode);
+    }
+  };
+  
+class ogzstream : public gzstreambase, public OSTREAM {
+  
+public:
+  ogzstream() : OSTREAM( &buf) {}
+  ogzstream( const char* name, int mode = std::ios::out)
+    : gzstreambase( name, mode), OSTREAM( &buf) {}  
+  gzstreambuf* rdbuf() { return gzstreambase::rdbuf(); }
+  void open( const char* name, int open_mode = std::ios::out) {
+    gzstreambase::open( name, open_mode);
+  }
+  
+};
+
+#ifdef GZSTREAM_NAMESPACE
+} // namespace GZSTREAM_NAMESPACE
+#endif
+
+#endif // GZSTREAM_H
+// ============================================================================
+// EOF //
+
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 2797)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 2800)
@@ -57,5 +57,5 @@
 int maxBatchSize = 50;
 
-int trianglesPerVirtualLeaf = 1000;
+int trianglesPerVirtualLeaf = INITIAL_TRIANGLES_PER_VIRTUAL_LEAVES;
 
 SceneQuery *sceneQuery = NULL;
@@ -83,4 +83,5 @@
 int queryCulledNodes = 0;
 int stateChanges = 0;
+int numBatches = 0;
 
 bool showHelp = false;
@@ -98,4 +99,6 @@
 bool useRenderQueue = true;
 bool useMultiQueries = true;
+
+bool flyMode = true;
 
 /// the accumulated z axis rotation
@@ -233,5 +236,6 @@
 	visualization = new Visualization(bvh, camera, NULL, &state);
 
-	//sceneQuery = new SceneQuery(bvh->GetBox(), traverser);
+	sceneQuery = new SceneQuery(bvh->GetBox(), traverser);
+
 
 	glutMainLoop();
@@ -270,5 +274,5 @@
 	glEnable(GL_CULL_FACE);
 	//glDisable(GL_CULL_FACE);
-	
+	glDisable(GL_TEXTURE_2D);
 
 	GLfloat ambientColor[] = {0.5, 0.5, 0.5, 1.0};
@@ -292,5 +296,6 @@
 		"'F3'           - shows/hides bounds (boxes or tight bounds)",
 		"'F4'           - shows/hides statistics",
-		"'F5',          - shows/hides parameters",
+		"'F5',          - toggles between fly / walkmode",
+		"'F6',          - shows/hides parameters",
 		"'SPACE'        - cycles through occlusion culling algorithms",
 		"",
@@ -390,5 +395,6 @@
 	glEnable(GL_LIGHTING);
 	glEnable(GL_LIGHT0);
-	glEnable(GL_LIGHT1);
+	//glEnable(GL_LIGHT1);
+	glDisable(GL_LIGHT1);
 
 	//GLfloat ambient[] = {0.5, 0.5, 0.5, 1.0};
@@ -424,10 +430,10 @@
 
 	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
-	glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
-	//glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);
+	//glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
+	glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_FALSE);
 	//glLightModeli(GL_LIGHT_MODEL_COLOR_CONTROL_EXT, GL_SEPARATE_SPECULAR_COLOR_EXT);
 	glLightModeli(GL_LIGHT_MODEL_COLOR_CONTROL_EXT, GL_SINGLE_COLOR_EXT);
-
-}
+}
+
 
 void SetupEyeView()
@@ -476,6 +482,7 @@
 void Display() 
 {
+	Vector3 oldPos = camera->GetPosition();
+
 	PerfTimer frameTimer;
-
 	frameTimer.Start();
 
@@ -493,8 +500,18 @@
 		KeyVerticalMotion(KeyShift());
 
-	
 	Vector3 playerPos = camera->GetPosition();
-	//sceneQuery->CalcIntersection(playerPos);
+	
+	if (!flyMode)
+	{
+	Vector3 playerPos = camera->GetPosition();
+
+		bool validIntersect = sceneQuery->CalcIntersection(playerPos);
+
+		if (validIntersect &&
+			(( playerPos.z - oldPos.z) < bvh->GetBox().Size(2) * 1e-1f))
+		{
 	camera->SetPosition(playerPos);
+		}
+	}
 
 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
@@ -532,5 +549,5 @@
 		break;
 	case 32: //space
-		renderMode = (renderMode + 1) % RenderTraverser::NUM_RENDERMODES;
+		renderMode = (renderMode + 1) % RenderTraverser::NUM_TRAVERSAL_TYPES;
 		ResetTraverser();
 		break;
@@ -563,15 +580,9 @@
 		break;
 	case '8':
-		{
 			eightKeyPressed = true;
-			KeyVerticalMotion(-KeyShift());
 			break;
-		}
 	case '9':
-		{
 			nineKeyPressed = true;
-			KeyVerticalMotion(+KeyShift());
 			break;
-		}	
 	case 'o':
 	case 'O':
@@ -581,29 +592,17 @@
 	case 'a':
 	case 'A':
-		{
 			leftKeyPressed = true;
-			camera->Pitch(KeyRotationAngle());
-		}
 		break;
 	case 'd':
 	case 'D':
-	{
 			rightKeyPressed = true;
-			camera->Pitch(-KeyRotationAngle());
-		}
 		break;
 	case 'w':
 	case 'W':
-		{
 			upKeyPressed = true;
-			KeyHorizontalMotion(KeyShift());
-		}
 		break;
 	case 'x':
 	case 'X':
-		{
 			downKeyPressed = true;
-			KeyHorizontalMotion(-KeyShift());
-		}
 		break;
 	case 'r':
@@ -716,4 +715,7 @@
 	case GLUT_KEY_F5:
 		showOptions = !showOptions;
+		break;
+	case GLUT_KEY_F6:
+		flyMode = !flyMode;
 		break;
 	case GLUT_KEY_LEFT:
@@ -1004,5 +1006,5 @@
 	if (numbers.size() > 0)
 	{
-		sprintf_s(hstr, "%d", numbers.back());
+		sprintf(hstr, "%d", numbers.back());
 		str.append(hstr);
 	}
@@ -1010,5 +1012,5 @@
 	for (int i = (int)numbers.size() - 2; i >= 0; i--)
 	{
-		sprintf_s(hstr, ",%03d", numbers[i]);
+		sprintf(hstr, ",%03d", numbers[i]);
 		str.append(hstr);
 	}
@@ -1050,10 +1052,11 @@
 		issuedQueries = traverser->GetStats().mNumIssuedQueries;
 		stateChanges = traverser->GetStats().mNumStateChanges;
-	}
-
-	sprintf_s(msg2, "assumed visible frames: %4d, max batch size: %4d", 
+		numBatches = traverser->GetStats().mNumBatches;
+	}
+
+	sprintf(msg2, "assumed visible frames: %4d, max batch size: %4d", 
 		      assumedVisibleFrames, maxBatchSize);
 
-	sprintf_s(msg3, "render queue: %d, multiqueries: %d, tight bounds: %d", 
+	sprintf(msg3, "render queue: %d, multiqueries: %d, tight bounds: %d", 
 		      useRenderQueue, useMultiQueries, useTightBounds);
 
@@ -1064,15 +1067,15 @@
 	CalcDecimalPoint(str2, bvh->GetBvhStats().mTriangles);
 
-	sprintf_s(msg4, "rendered nodes: %6d (of %6d), rendered triangles: %s (of %s)", 
+	sprintf(msg4, "rendered nodes: %6d (of %6d), rendered triangles: %s (of %s)", 
 			  renderedNodes, bvh->GetNumVirtualNodes(), str.c_str(), str2.c_str()); 
 
-	sprintf_s(msg5, "traversed: %5d, frustum culled: %5d, query culled: %5d",
+	sprintf(msg5, "traversed: %5d, frustum culled: %5d, query culled: %5d",
 			  traversedNodes, frustumCulledNodes, queryCulledNodes);
 
-	sprintf_s(msg6, "issued queries: %5d, state changes: %5d", issuedQueries, stateChanges);
-
-	sprintf_s(msg8, "triangles per virtual leaf: %5d", trianglesPerVirtualLeaf);
-
-	sprintf_s(msg7, "fps: %6.1f", fps);
+	sprintf(msg6, "issued queries: %5d, state changes: %5d, render batches: %5d", issuedQueries, stateChanges, numBatches);
+
+	sprintf(msg8, "triangles per virtual leaf: %5d", trianglesPerVirtualLeaf);
+
+	sprintf(msg7, "fps: %6.1f", fps);
 
 
@@ -1085,5 +1088,6 @@
 	else
 	{
-		glColor3f(1.0f, 1.0f, 1.0f);
+	//	glColor3f(1.0f, 1.0f, 1.0f);
+		glColor3f(1.0f, 0.0f, 0.0f);
 		Output(850, 30, msg[renderMode]);
 
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/CHCPlusPlusTraverser.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/CHCPlusPlusTraverser.cpp	(revision 2795)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/CHCPlusPlusTraverser.cpp	(revision 2800)
@@ -15,7 +15,11 @@
 void CHCPlusPlusTraverser::HandleQueryResult(OcclusionQuery *query)
 {
+	waitTimer.Entry();
+
 	// wait until result available
 	const int visible = query->GetQueryResult() > mVisibilityThreshold;
 
+	waitTimer.Exit();
+
 	// multiquery
 	if (query->GetSize() > 1)
@@ -27,6 +31,11 @@
 			{
 				BvhNode *node = query->GetNodes()[i];
+#if 1
+				mIQueue.push_back(node);
+				node->SetLastQueriedFrame(mFrameId);
+#else
 				OcclusionQuery *q = IssueOcclusionQuery(node);
 				mQueryQueue.push(q);
+#endif
 			}
 		}
@@ -38,4 +47,5 @@
 				node->IncTimesTestedInvisible();
 				node->SetVisible(false);
+				node->SetLastQueriedFrame(mFrameId);
 			}
 
@@ -46,4 +56,6 @@
 	{
 		BvhNode *node = query->GetFrontNode();
+
+		node->SetLastQueriedFrame(mFrameId);
 
 		// failed query: query individual nodes
@@ -100,4 +112,5 @@
 			mQueryQueue.pop();
 
+			// waiting for query result
 			HandleQueryResult(query);
 		}	
@@ -186,4 +199,5 @@
 	if (mUseRenderQueue) ApplyRenderQueue();
 
+	restTimer.Entry();
 
 	//////////////
@@ -206,11 +220,12 @@
 		HandleQueryResult(query);
 	}
-}
-
+
+	restTimer.Exit();
+}
 
 
 void CHCPlusPlusTraverser::QueryPreviouslyInvisibleNodes(BvhNode *node)
 {
-	mIQueue.push(node);
+	mIQueue.push_back(node);
 
 	if (mIQueue.size() > mMaxBatchSize)
@@ -221,5 +236,5 @@
 
 
-OcclusionQuery * CHCPlusPlusTraverser::GetNextMultiQuery(BvhNodeQueue &iqueue)
+OcclusionQuery * CHCPlusPlusTraverser::GetNextMultiQuery(BvhNodeContainer &iqueue)
 {
 	OcclusionQuery *query = mQueryHandler.RequestQuery();
@@ -233,10 +248,15 @@
 	while (!iqueue.empty())
 	{
-		BvhNode *node = iqueue.front();
+		BvhNode *node = iqueue.back();
+
+		// node was already part of a mulitquery => avoid recursion
+		if (node->GetLastQueriedFrame() == mFrameId)
+			newPBatch = 0;
+		else
 		newPBatch *= mVisibilityPredictor.GetProbability(node);
 
 		if (query->GetNodes().empty())
 		{
-			// single node will anever cause a wasted query
+			// single node will never cause a wasted query
 			newBatchVal = 1.0f;
 		}
@@ -250,5 +270,5 @@
 			break;
 
-		iqueue.pop();
+		iqueue.pop_back();
 		query->AddNode(node);
 
@@ -263,25 +283,31 @@
 
 
+static inline bool lt(BvhNode *a, BvhNode *b)
+{
+	return a->GetTimesTestedInvisible() < b->GetTimesTestedInvisible();
+}
+
+
 void CHCPlusPlusTraverser::IssueMultiQueries()
 {
-	while (!mIQueue.empty())
-	{
-		OcclusionQuery *query;
-
-		if (mUseMultiQueries)
-		{
-			query = GetNextMultiQuery(mIQueue);
+	if (mUseMultiQueries)
+	{
+		// sort queries by #times invisible
+		sort(mIQueue.begin(), mIQueue.end(), lt);
+
+		while (!mIQueue.empty())
+			mQueryQueue.push(GetNextMultiQuery(mIQueue));
 		}
 		else
 		{
-			BvhNode *node = mIQueue.front();
-			mIQueue.pop();
-			query = IssueOcclusionQuery(node);
-		}
-
-		mQueryQueue.push(query);
-	}
-}
-
-
-}
+		BvhNodeContainer::const_iterator it, it_end = mIQueue.end();
+
+		for (it = mIQueue.begin(); it != it_end; ++ it)
+			mQueryQueue.push(IssueOcclusionQuery(*it));
+
+		mIQueue.clear();
+	}
+}
+
+
+}
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BvhLoader.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BvhLoader.cpp	(revision 2796)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BvhLoader.cpp	(revision 2800)
@@ -103,7 +103,6 @@
 	bvh->PostProcess();
 	
-	const int trianglesPerVirtualLeaves = 1000;
 	// set virtual leaves for specified number of triangles
-	bvh->SetVirtualLeaves(trianglesPerVirtualLeaves);
+	bvh->SetVirtualLeaves(INITIAL_TRIANGLES_PER_VIRTUAL_LEAVES);
 
 	bvh->UpdateNumLeaves(bvh->mRoot);
